$ ======================================================================
$
$   TOPPERS/HRP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       High Reliable system Profile Kernel
$
$   Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$  
$   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
$   ܥեȥѤΤޤࡥʲƱˤѡʣ
$   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
$   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
$       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
$       ˴ޤޤƤ뤳ȡ
$   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
$       ѤǤǺۤˤϡۤȼɥȡ
$       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
$       ̵ݾڵǺܤ뤳ȡ
$   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
$       ѤǤʤǺۤˤϡΤ줫ξ
$       ȡ
$     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
$         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
$     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
$         𤹤뤳ȡ
$   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
$       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
$       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
$       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
$       դ뤳ȡ
$  
$   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
$   TOPPERSץȤϡܥեȥ˴ؤơλŪ
$   ФŬޤơʤݾڤԤʤޤܥեȥ
$   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
$   Ǥʤ
$
$   $Id: kernel_opt.tf 806 2012-10-01 07:23:18Z ertl-hiro $
$  
$ =====================================================================

$
$  ѥ2ξɹ
$
$INCLUDE "cfg2_out.tf"$

$
$  ǡLMAVMAؤΥԡ
$
$FOREACH lma LMA.ORDER_LIST$
	$start_data = SYMBOL(LMA.START_DATA[lma])$
	$end_data = SYMBOL(LMA.END_DATA[lma])$
	$start_idata = SYMBOL(LMA.START_IDATA[lma])$
	$IF !LENGTH(start_data)$
		$ERROR$$FORMAT(_("symbol '%1%' not found"), LMA.START_DATA[lma])$$END$
	$ELIF !LENGTH(end_data)$
		$ERROR$$FORMAT(_("symbol '%1%' not found"), LMA.END_DATA[lma])$$END$
	$ELIF !LENGTH(start_idata)$
		$ERROR$$FORMAT(_("symbol '%1%' not found"), LMA.START_IDATA[lma])$$END$
	$ELSE$
		$BCOPY(start_idata, start_data, end_data - start_data)$
	$END$
$END$

$ =====================================================================
$ kernel_mem3.cζʬ
$ =====================================================================

$FILE "kernel_mem3.c"$
/* kernel_mem3.c */$NL$
#include "kernel/kernel_int.h"$NL$
#include "kernel_cfg.h"$NL$
$NL$
#if TKERNEL_PRID != 0x06u$NL$
#error "The kernel does not match this configuration file."$NL$
#endif$NL$
$NL$

/*$NL$
$SPC$*  Include Directives (#include)$NL$
$SPC$*/$NL$
$NL$
$INCLUDES$
$NL$

$ =====================================================================
$ ܥȲꥪ֥Ƚ֥åɹ
$ =====================================================================

$
$ ܥȲꥪ֥Ƚ֥åɹ
$
$ MO.BASEADDR[moid]ꥪ֥ȤƬ
$ MO.LIMITADDR[moid]ꥪ֥Ȥξ

$IF !OMIT_STANDARD_MEMINIB$
	$MO_MEMTOP_LIST = {}$
	$memtop_table = SYMBOL("_kernel_memtop_table")$
	$offset = 0$
	$FOREACH moid MO_START_LIST$
		$IF MO.LINKER[moid]$
			$MO.BASEADDR[moid] = SYMBOL(CONCAT("__start_", MO.MLABEL[moid]))$
			$MO.LIMITADDR[moid] = SYMBOL(CONCAT("__limit_", MO.MLABEL[moid]))$
		$ELSE$
			$MO.BASEADDR[moid] = PEEK(memtop_table + offset, sizeof_void_ptr)$
			$offset = offset + sizeof_void_ptr$
			$MO.LIMITADDR[moid] = (MO.BASEADDR[moid] + MO.SIZE[moid]) & ((1 << sizeof_void_ptr * 8) - 1)$
		$END$
	$END$
$END$

$ =====================================================================
$ Υ깽ե
$ =====================================================================

$
$  ꥪ֥Ƚ֥å
$
$IF ISFUNCTION("GENERATE_MEMINIB_TABLE")$
$	// åȰ¸Υꥪ֥Ƚ֥åƤ
	$GENERATE_MEMINIB_TABLE()$
$ELIF !OMIT_STANDARD_MEMINIB$
	$IF LENGTH(OPTIMIZE_MEMINIB)$
$		// ɥ쥹0֤ΰ
		$tsize_meminib = 1$
		$FOREACH moid MO_START_LIST$
$			// 0Ǥʤꥪ֥ȤƬϤ֤ΰ
			$IF MO.BASEADDR[moid] != MO.LIMITADDR[moid]$
				$tsize_meminib = tsize_meminib + 1$
			$END$
			$IF !MO.LINKER[moid]$
$				// 󥫤֤ʤꥪ֥ȤϺǽϤɬ
				$tsize_meminib = tsize_meminib + 1$
			$ELIF (MO.SEFLAG[MO.MOEND[moid]] & 0x80) != 0$
$				// ꡼κǸΥꥪ֥ȤϺǽϤɬ
				$tsize_meminib = tsize_meminib + 1$
			$END$
		$END$

$		// åȰ¸tsize_meminib
		$IF ISFUNCTION("CALC_TSIZE_MEMINIB")$
			$CALC_TSIZE_MEMINIB()$
		$END$
	$END$

	const uint_t _kernel_tnum_meminib = $tsize_meminib$U;$NL$
	$NL$

	void *const _kernel_memtop_table[$tsize_meminib$] = {
	$IF LENGTH(MO_START_LIST_NOLINKER)$
		$NL$
		$JOINEACH moid MO_START_LIST_NOLINKER ",\n"$
			$TAB$(void *)($MO.BASE[moid]$)
		$END$$NL$
	$ELSE$
		$SPC$0$SPC$
	$END$
	};$NL$
	$NL$

	const MEMINIB _kernel_meminib_table[$tsize_meminib$] =
	$SPC${{ TA_NULL, 0U, 0U, 0U }};$NL$
	$NL$
$END$

$
$  data֥å
$
$IF LENGTH(OPTIMIZE_DATASEC_LIST) && !OMIT_IDATA && LENGTH(DATASEC_LIST)$
$	// data֥åΥŬ
$	// 0ǤʤdataΥꥹȡMO_DATASEC_LISTˤ
	$MO_DATASEC_LIST = {}$
	$FOREACH moid DATASEC_LIST$
		$IF MO.BASEADDR[moid] != MO.LIMITADDR[moid]$
			$MO_DATASEC_LIST = APPEND(MO_DATASEC_LIST, moid)$
		$END$
	$END$

$	// ѥ4˰Ϥ
	$DATASEC_LIST = MO_DATASEC_LIST$
	$DATASEC_LIST_OPTIMIZED = 1$
$END$

$	// dataοdata֥å
$IF !OMIT_IDATA && LENGTH(DATASEC_LIST)$
	const uint_t _kernel_tnum_datasec = $LENGTH(DATASEC_LIST)$U;$NL$
	const DATASECINIB _kernel_datasecinib_table[$LENGTH(DATASEC_LIST)$] =
	$SPC${{ 0, 0, 0 }};$NL$
$ELSE$
	const uint_t _kernel_tnum_datasec = 0U;$NL$
	TOPPERS_EMPTY_LABEL(const DATASECINIB, _kernel_datasecinib_table);$NL$
$END$$NL$

$
$  bss֥å
$
$IF LENGTH(OPTIMIZE_BSSSEC_LIST) && LENGTH(BSSSEC_LIST)$
$	// bss֥åΥŬ
$	// 0ǤʤbssΥꥹȡMO_BSSSEC_LISTˤ
	$MO_BSSSEC_LIST = {}$
	$FOREACH moid BSSSEC_LIST$
		$IF MO.BASEADDR[moid] != MO.LIMITADDR[moid]$
			$MO_BSSSEC_LIST = APPEND(MO_BSSSEC_LIST, moid)$
		$END$
	$END$

$	// ѥ4˰Ϥ
	$BSSSEC_LIST = MO_BSSSEC_LIST$
	$BSSSEC_LIST_OPTIMIZED = 1$
$END$

$	// bssοbss֥å
$IF LENGTH(BSSSEC_LIST)$
	const uint_t _kernel_tnum_bsssec = $LENGTH(BSSSEC_LIST)$U;$NL$
	const BSSSECINIB _kernel_bsssecinib_table[$LENGTH(BSSSEC_LIST)$] =
	$SPC${{ 0, 0 }};$NL$
$ELSE$
	const uint_t _kernel_tnum_bsssec = 0U;$NL$
	TOPPERS_EMPTY_LABEL(const BSSSECINIB, _kernel_bsssecinib_table);$NL$
$END$$NL$

$ =====================================================================
$  ѥ4Ϥ
$ =====================================================================

$FILE "cfg3_out.tf"$
$$ cfg3_out.tf$NL$
$NL$

$ tsize_meminibν
$IF !OMIT_STANDARD_MEMINIB$
	$$tsize_meminib = $tsize_meminib$$$$NL$
	$NL$
$END$

$ DATASEC_LISTMO_DATASEC_LISTDATASEC_LIST_OPTIMIZEDν
$$DATASEC_LIST = { $DATASEC_LIST$ }$$$NL$
$IF LENGTH(DATASEC_LIST_OPTIMIZED)$
	$$MO_DATASEC_LIST = { $MO_DATASEC_LIST$ }$$$NL$
	$$DATASEC_LIST_OPTIMIZED = $DATASEC_LIST_OPTIMIZED$$$$NL$
$END$
$NL$

$ BSSSEC_LISTMO_BSSSEC_LISTBSSSEC_LIST_OPTIMIZEDν
$$BSSSEC_LIST = { $BSSSEC_LIST$ }$$$NL$
$IF LENGTH(BSSSEC_LIST_OPTIMIZED)$
	$$MO_BSSSEC_LIST = { $MO_BSSSEC_LIST$ }$$$NL$
	$$BSSSEC_LIST_OPTIMIZED = $BSSSEC_LIST_OPTIMIZED$$$$NL$
$END$
$NL$
